﻿# Bonus plugin for Deathrun Mod v 1.8
# Visit our DeathRun Server 195.211.101.189:27016
# Visit our site www.tk-portal.ru

import es
import playerlib
import langlib
import keyfile
import spe

deathrun_noblock = es.ServerVar("deathrun_noblock")
deathrun_armor = es.ServerVar("deathrun_armor")
deathrun_nightvision = es.ServerVar("deathrun_nightvision")
deathrun_crysisskin = es.ServerVar("deathrun_crysisskin")
deathrun_givefragter = es.ServerVar("deathrun_givefragter")
deathrun_savescores = es.ServerVar("deathrun_savescores")

data = {}
text = langlib.Strings("cstrike/addons/eventscripts/deathrun/language/bonus.ini")

def load():
    es.server.cmd("es_xmexec ../addons/eventscripts/deathrun/deathrun.cfg")
    global data
    gdload()
    data.clear()
    if int(deathrun_crysisskin) == 1:
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit.vtf')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit.vmt')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_bump.vtf')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_helm.vtf')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_helm.vmt')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_helm_bump.vtf')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_visir.vtf')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_visir.vmt')
        es.server.queuecmd('downloadable materials/models/player/slow/nanosuit/slow_nanosuit_visir_bump.vtf')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.dx80.vtx')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.dx90.vtx')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.mdl')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.phy')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.sw.vtx')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.vvd')
        es.server.queuecmd('downloadable models/player/slow/nanosuit/slow_nanosuit.xbox.vtx')
    if int(deathrun_savescores) == 1:
        for userid in es.getUseridList():
            data[es.getplayersteamid(userid)] = {}
            data[es.getplayersteamid(userid)]['score'] = playerlib.getPlayer(userid).attributes['kills']
            data[es.getplayersteamid(userid)]['dead'] = playerlib.getPlayer(userid).attributes['deaths']

def gdload():
    global offsets
    platform = "windows"
    if spe.platform != "nt":
        platform = "linux"
    offsets = keyfile.Parse(es.getAddonPath("deathrun") + "/gamedata.txt")[es.getGameName()]["#Offsets"]
    for offset in offsets:
        offsets[offset] = (offsets[offset]["type"], int(offsets[offset][platform]))

def es_map_start(event_var): 
    es.server.cmd("es_xmexec ../addons/eventscripts/deathrun/deathrun.cfg")
    gdload()
    data.clear()

def setOffsetValue(pointer, offset, value):
    spe.setLocVal(offsets[offset][0], pointer + offsets[offset][1], value)

def round_start(event_var):
    es.server.cmd("es_xmexec ../addons/eventscripts/deathrun/deathrun.cfg")

def player_spawn(event_var):
    global data
    tokens = {}
    userid = int(event_var['userid'])
    steamid = event_var['es_steamid']
    player = playerlib.getPlayer(userid)
    if int(deathrun_savescores) == 0:
        score = player.attributes['kills']
    else:
        if data.has_key(steamid):
            if data[steamid]['score'] != player.attributes['kills']:
                es.server.queuecmd('score set %s %s'%(userid,data[steamid]['score']))
            if player.attributes['kills'] < 0:
                es.server.queuecmd('score set %s 0'%userid)
                data[steamid]['score'] = 0
            if data[steamid]['dead'] != player.attributes['deaths']:
                setOffsetValue(spe.getPlayer(userid), "m_iDeaths", data[steamid]['dead'])
            score = data[steamid]['score']
    if es.getplayerteam(userid) == 2:
        es.tell(userid, "#green", text("becometer", tokens, player.get("lang")))
    if int(deathrun_noblock) == 1:
        es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    es.fire(userid, "!self", "addoutput", "gravity 1")
    if es.getplayerteam(userid) == 3 and data.has_key(steamid):
        if int(deathrun_armor) == 1:
            player.set("armor", "125")
        if int(deathrun_nightvision) == 1:
            player.set("nightvision", 1)
        if score == 1:
            player.set("speed", 1.05)
            player.set("health", 105)
            es.tell(userid, "#multi", text("1frag", tokens, player.get("lang")))
        elif score == 2:
            player.set("speed", 1.10)
            player.set("health", 110)
            es.tell(userid, "#multi", text("2frags", tokens, player.get("lang")))
        elif score == 3:
            player.set("speed", 1.10)
            player.set("health", 115)
            es.fire(userid, "!self", "addoutput", "gravity 0.9")
            es.tell(userid, "#multi", text("3frags", tokens, player.get("lang")))
        elif score == 4:
            player.set("speed", 1.10)
            player.set("health", 120)
            es.fire(userid, "!self", "addoutput", "gravity 0.9")	
            es.tell(userid, "#multi", text("4frags", tokens, player.get("lang")))
        elif score == 5:
            player.set("speed", 1.15)
            player.set("health", 125)
            es.fire(userid, "!self", "addoutput", "gravity 0.85")
            es.tell(userid, "#multi", text("5frags", tokens, player.get("lang")))
        elif score == 6:
            player.set("speed", 1.15)
            player.set("health", 130)
            es.fire(userid, "!self", "addoutput", "gravity 0.85")       
            es.tell(userid, "#multi", text("6frags", tokens, player.get("lang")))
        elif score == 7:
            player.set("speed", 1.15)
            player.set("health", 135)
            es.fire(userid, "!self", "addoutput", "gravity 0.8")
            es.tell(userid, "#multi", text("7frags", tokens, player.get("lang")))
        elif score == 8:
            player.set("speed", 1.15)
            player.set("health", 140)
            es.fire(userid, "!self", "addoutput", "gravity 0.8")
            es.tell(userid, "#multi", text("8frags", tokens, player.get("lang")))
        elif score == 9:
            player.set("speed", 1.2)
            player.set("health", 145)
            es.fire(userid, "!self", "addoutput", "gravity 0.75")
            es.tell(userid, "#multi", text("9frags", tokens, player.get("lang")))
        elif score > 9:
            player.set("speed", 1.25)
            player.set("health", 150)
            es.fire(userid, "!self", "addoutput", "gravity 0.7")
            es.tell(userid, "#multi", text("tenfrags", tokens, player.get("lang")))
            if int(deathrun_crysisskin) == 1:
                player.setModel('player/slow/nanosuit/slow_nanosuit.mdl')

def player_death(event_var):
    global data
    userid = int(event_var['userid'])
    steamid = event_var['es_steamid']
    attacker = int(event_var['attacker'])
    playerlib.getPlayer(userid).set("speed", 1)
    data[es.getplayersteamid(userid)]['dead'] += 1
    if int(deathrun_savescores) == 1 and int(es.getplayerteam(attacker)) != int(es.getplayerteam(userid)):
        if int(es.getplayerteam(attacker)) == 2 or int(es.getplayerteam(attacker)) == 3:
            data[event_var['es_attackersteamid']]['score'] += 1
    if int(deathrun_givefragter) == 1:
        if es.getlivingplayercount(3) < 1 and es.getlivingplayercount(2) > 0:
            for userid in es.getUseridList():
                if es.getplayerteam(userid) == 2 and not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    setOffsetValue(spe.getPlayer(userid), "m_iFrags", +1)
		    if int(deathrun_savescores) == 1:
		        data[es.getplayersteamid(userid)]['score'] += 1

def player_team(event_var):
    global data
    userid = int(event_var['userid'])
    steamid = es.getplayersteamid(userid) 
    if not data.has_key(steamid):
        data[steamid] = {}
        data[steamid]['score'] = 0
        data[steamid]['dead'] = 0